{% extends "base.html" %}
{% block content %}
<!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script> -->
<link rel="stylesheet" href="../static/custom.css">
<script src="../static/node_modules/file-saverjs/FileSaver.js"></script>
<script src="../node_modules/tableexport/src/stable/js/tableexport.js"></script>



<script type="text/javascript">
//Script for dynamically creating the table
  $(document).ready(function (report) {
    console.log("reportDict:")
    var reportDict = {{ FullReportJson|safe }};
    console.log(reportDict);
    var report = reportDict.report;
    var reportDate = reportDict.date;
    console.log('reportDate:');
    console.log(reportDate);
    var reportIdentity = reportDict.identity;
    console.log("reportIdentity:");
    console.log(reportIdentity);
    var missing = reportDict.missing;
    var exceptions = reportDict.exceptions;
    report ? console.log('reportStr Exists!') : console.log('Doesn\'t exist!');
    console.log(report);
    console.log("Missing: ");
    console.log(missing);
    console.log("Exceptions: ");
    console.log(exceptions);
    function test_func(report) {
      console.log("Test function activated");
      console.log(report);
    }
    test_func(report);

    // var report = reportStr;
    // console.log("report: ");
    // console.log(report);
    
    function build_table(report, reportDate, reportIdentity) {
      // console.log("report2: ");
      // console.log(report);
      var report_data = '';
      var arrayLength = report.length;
        for (var i = 0; i < arrayLength; i++) {
          // alert(report[i]);
          var reportData = report[i];
          console.log("reportData")
          console.log(reportData)
          var reportDateCurr = reportDate[i];
          console.log("reportDateCurr")
          console.log(reportDateCurr)
          var reportIdentityCurr = reportIdentity[i];
          console.log("reportIdentityCurr")
          console.log(reportIdentityCurr)
          arrayLength2 = reportData.length;
          for (var z = 0; z < arrayLength2; z++) {
            var itemData = reportData[z];
            var itemDate = reportDateCurr['dateTime'];
            var itemCSC = reportIdentityCurr['CSC'];
            console.log('itemData: ');
            console.log(itemData);
            console.log('itemDate: ');
            console.log(itemDate);
            console.log('itemIdentity: ');
            console.log(itemCSC);
            report_data += '<tr>\n';
            report_data += '<td>' + itemCSC + '</td>\n';
            report_data += '<td>' + itemData.FY + '</td>\n';
            // report_data += '<td>' + itemData.ID + '</td>\n';
            report_data += '<td>' + itemData.ObjectType + '</td>\n';
            report_data += '<td> <a href="' + itemData.URL + '" target="_blank">' + itemData.name + '</a></td>\n';
            report_data += '<td>' + itemData.project + '</td>\n';
            report_data += '<td id="ElipseDataShort">' + itemData.DataInProject + '</td>\n';
            report_data += '<td id="ElipseDataLong">' + itemData.DataPerFile + '</td>\n';
            report_data += '<td id="ElipseDataShort">' + itemData.totalFYData + '</td>\n';
            report_data += '<td>' + itemDate.slice(0, -7) + '</td>\n';
            // report_data += '<td id="ElipseDataShort">' + itemData.RunningDataTotal + '</td>\n';
            report_data += '</tr>\n';
          }
        }
      $('#reportTable').append(report_data);
      };
      build_table(report, reportDate, reportIdentity);
    });
</script>
<script type="text/javascript">
//script for downloading table as excel.
  $(document).ready(function () {
    $("#btnExport").click(function (e) {
      e.preventDefault();

      //getting data from our table
      var data_type = 'data:application/vnd.ms-excel';
      var table_div = document.getElementById('table_wrapper');
      var table_html = table_div.outerHTML.replace(/ /g, '%20');

      var table = TableExport(document.getElementById("export-buttons-table"));
      table.click();
    });
  });
  $(document).ready(function () {
    $("#btnExport2").click(function (e) {
      e.preventDefault();

      //getting data from our table
      var data_type = 'data:application/vnd.ms-excel';
      var table_div = document.getElementById('table_wrapper');
      var table_html = table_div.outerHTML.replace(/ /g, '%20');

      var a = document.createElement('a');
      a.href = data_type + ', ' + table_html;
      a.download = 'sbMacro_Report' + Math.floor((Math.random() * 9999999) + 1000000) + '.xls';
      a.click();
    });
  });

</script>

<div>
  <h1>sbMACRO Query Results</h1>
  <br>
  <p>Below is a table showing your query results from <a href="http://www.sciencebase.gov" >ScienceBase.gov</a></p>
  
</div>
<div id="container">
  <button class="btn wave-effect waves-teal disabled" id="btnExport">Export to Excel (.xlsx)</button>
  <button class="btn wave-effect waves-teal" id="btnExport2">Export to Excel (.xls)</button>
  <div id="table_wrapper">
    <table class="bordered highlight striped centered responsive-table" id="reportTable">
      <thead>
        <th>Climate Science Center</th>
        <th>Fiscal Year</th>
        <!-- <th>ID</th> -->
        <th>Object Type</th>
        <th>Name</th>
        <th>Project</th>
        <th>Data in Project (GB)</th>
        <th>Data per File (KB)</th>
        <th>Total Data in Fiscal Year (GB)</th>
        <th>sbMACRO Data Retrieval Date</th>
        <!-- <th>Running Data Total (GB)</th> -->
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
</div>


<!-- <div id="reportDiv">
  <br>
  <br>
  <h1>Here is the report generated by sbMACRO</h1>
  <br>
  <table class="table table-bordered table-striped" id="reportTable">
    <tr>
      <th>ID</th>
      <th>Object Type</th>
      <th>Name</th>
      <th>Fiscal Year</th>
      <th>Project</th>
      <th>Data in Project (GB)</th>
      <th>Data per File (KB)</th>
      <th>Total Data in Fiscal Year</th>
      <th>Running Data Total (GB)</th>
    </tr>
  </table>
  
</div> -->
<!-- <div id="missingDiv">

</div>
<div id="exceptionsDiv">

</div> 
<div>-->
  <!-- <p>beginning of script div</p> -->
  <script type="text/javascript">
    
    // console.log("Trying!")
    // var reportDict = {{ FullReportJson|safe }};
    // var reportStr = reportDict.report;
    // var missing = reportDict.missing;
    // var exceptions = reportDict.exceptions;
    // reportStr ? console.log('Exists!') : console.log('Doesn\'t exist!');
    // console.log(reportStr);
    // console.log("Missing: " + missing);
    // console.log("Exceptions: " + exceptions);
    // function test_func(reportStr) {
    //   console.log("reportStr: "+reportStr);
    // }
    // test_func(reportStr)

    // var report = reportStr;
    // console.log("report! "+report);
    // report = JSON && JSON.parse(reportStr) || $.parseJSON(reportStr); // This will ensure you use native JSON.parse immediately, rather than having jQuery perform sanity checks on the string before passing it to the native parsing function. https://stackoverflow.com/questions/4935632/parse-json-in-javascript
    
    

    //Doesn't work:
  //  $(document).ready(function(report){
  //    console.log("report1: "+report)
  //    $(function(report){
  //      console.log("report2: "+report) 
  //      var report_data = '';
  //      $.each(report, function(key, value){//somewhere in here there's a problem.
  //        console.log("Key: "+key);
  //        $each(key, function(key2, value2){
  //          console.log("key2: "+key2);
  //          report_data += '<tr>';
  //          report_data += '<td>'+value.ID+'</td>';
  //          report_data += '<td>'+value.ObjectType+'</td>';
  //          report_data += '<td>'+value.name+'</td>';
  //          report_data += '<td>'+value.FY+'</td>';
  //          report_data += '<td>'+value.project+'</td>';
  //          report_data += '<td>'+value.DataInProject+'</td>';
  //          report_data += '<td>'+value.DataPerFile+'</td>';
  //          report_data += '<td>'+value.totalFYData+'</td>';
  //          report_data += '<td>'+value.RunningDataTotal+'</td>';
  //          report_data += '</tr>';
  //        });
 
  //      });
  //      $('#reportTable').append(report_data);
  //    });
  //  });

    // $(document).ready(function (table){
    //   $("#reportDiv").addClass("Table"); //Adds the Table class from custom.css
    //   $("#reportDiv").append(table);
    //   var table = $("<table></table>"); //creates a table element
    //   var tr = $("<tr></tr>"); // creates a table row element
    //   var th = $("<th></th>"); // creates a table head cell element
    //   var td = $("<td></td>"); // creates a table data cell element
    //   for (var key in report) {
    //       if (report.hasOwnProperty(key)) {
    //         console.log("key: " + key);
    //         var th2 = $(th).text(key);
    //         $(table).append(th2);
    //         //console.log(table);
    //         var list = key[key];
    //         console.log("list?: " + list);
    //         for (var list2 in key) {
    //            console.log(list2);
    //         //   // var item = key[i];
    //         //   // console.log(item)

    //         //   // i = 0; i < key.length; i++){ 

    //         //   for (var item in list){
    //         //     var tr2 = $(table).append(tr);
    //         //     $(tr2).text(item);
    //         }
    //         //}
    //       }
    //     }
    //   console.log(table);
    // });
    
    //What I need to do now it this:
    /*
    Create a table with all the info in the json dynamically using javascript. 

    Have a button 'download report' that takes the json and creates an excel file (using some library) for download (using file-saverjs)

    In a div, 
      if report isn't empty
        create a column with a heading of the key 'ID'
          for each item in reports.ID, add it a row and add the contents to the first column
        create a column with a heading of the key 'Object Type'
          for each item in reports.ObjectType(?), add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Name'
          for each item in reports.Name, add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Fiscal Year'
          for each item in reports.FiscalYear(?), add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Project'
          for each item in reports.Project, add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Data in Project (GB)'
          for each item in reports['Data in Project (GB)'](?), add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Data per File (KB)'
          for each item in reports['Data per File (KB)'], add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Fiscal Year Total Data (GB)'
          for each item in reports['Fiscal Year total Data (GB)'], add the contents to the corresponding row beginning with the second one (first one under the heading.)
        create a column with a heading of the key 'Running Data Total (GB)'
          for each item in reports['Running Data Total (GB)'], add the contents to the corresponding row beginning with the second one (first one under the heading.)
      if missing doesn't equal 'None'
        create a new div under the previous div holding the report table
          create a new table with a header row
            create a column with the heading of the key 'Missing Data ID'
              for each item, create a row with the table data equal to the item.
            create a column with the heading of the key 'Missing Data URL'
              for each item, create a row with the table data equal to the item.
      if exceptions doesn't equal 'None'
        create a new div under the previous div holding either the report table or the missing table
          create a new table with a header row
            create a column with the heading of the key 'Exception/Permission Issue ID'
              for each item, create a row with the table data equal to the item.
            create a column with the heading of the key 'Exception/Permission Issue URL'
              for each item, create a row with the table data equal to the item.
              */
  </script>

{% endblock %}
